<?php
//京都
// 圧縮するディレクトリー
$this_file_path = __FILE__;
$this_file_path = preg_replace('@zip/zip_b.php@s','',$this_file_path);
$dir = $this_file_path;
// Zipファイルの保存先
$file = './a.zip';
 
zipDirectory($dir, $file);

// ディレクトリを圧縮する
function zipDirectory($dir, $file, $root=""){
    $zip = new ZipArchive();
    $res = $zip->open($file, ZipArchive::CREATE);
 
    if($res){
        // $rootが指定されていればその名前のフォルダにファイルをまとめる
        if($root != "") {
            $zip->addEmptyDir($root);
            $root .= DIRECTORY_SEPARATOR;
        }
 
        $baseLen = mb_strlen($dir);
         
        $iterator = new RecursiveIteratorIterator(
            new RecursiveDirectoryIterator(
                $dir,
                FilesystemIterator::SKIP_DOTS
                |FilesystemIterator::KEY_AS_PATHNAME
                |FilesystemIterator::CURRENT_AS_FILEINFO
            ), RecursiveIteratorIterator::SELF_FIRST
        );
 
        $list = array();
        foreach($iterator as $pathname => $info){
            $localpath = $root . mb_substr($pathname, $baseLen);
         
            if( $info->isFile() ){
                $zip->addFile($pathname, $localpath);
            } else {
                $res = $zip->addEmptyDir($localpath);
            }
        }
 
        $zip->close();
echo ok;
    } else {
        return false;
    }
}

?>